<?php
namespace Teknisa\PED\Modules\Pedidos\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class ped00300AprovacaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }


    const CHECK_LOGIN = "SELECT CDOPERADOR
                              NMOPERADOR,
                              DSEMAILOPER,
                              CDSENHAOPERWEB
                            FROM OPERADOR
                            WHERE DSEMAILOPER  = :P_DSEMAILOPER
                            AND CDSENHAOPERWEB = :P_CDSENHAOPERWEB";
    public function getLogin($param = null) {
        try {
            $sql = "SELECT OP.CDOPERADOR, GR.CDGRUPOPER, OP.NMOPERADOR, OP.DSEMAILOPER, OP.CDSENHAOPERWEB
                    FROM OPERADOR OP
                    JOIN OPERGRUPOP GR ON OP.CDOPERADOR = GR.CDOPERADOR";
            if (!$param) {
                $std = $this->connection->prepare($sql);
                $std->execute();
                return $std->fetchAll();
            } else {
                $params = array(
                    'P_DSEMAILOPER' => $param['login'],
                    'P_CDSENHAOPERWEB' => $param['senha']
                );
                $std = $this->connection->prepare(self::CHECK_LOGIN);
                $std->execute($params);
                $result = $std->fetchAll();
                return $result;
            }
        }catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_GRUPO_OPER = "SELECT
                        GR.CDGRUPOPER
                    FROM OPERADOR OP,
                        OPERGRUPOP GR
                    WHERE
                        OP.CDOPERADOR = GR.CDOPERADOR
                    AND OP.DSEMAILOPER = :P_DSEMAILOPER";
    public function getGrupoOper($login) {
        try {
            $params = array(
                'P_DSEMAILOPER' => $login['login']
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_GRUPO_OPER, $params);

        }catch (\Exception $e) {
            throw $e;
        }
    }
    const parampedido = "SELECT
                            CDGROPERAPRO
                        FROM PARAMPEDIDO
                        WHERE CDFILIAL = :P_CDFILIAL";
    public function getParampedidos($filial) {
        try {
            $params = array(
                'P_CDFILIAL' => $filial
            );
            return $this->entityManager->getConnection()->fetchAll(self::parampedido, $params);

        }catch (\Exception $e) {
            throw $e;
        }
    }
}

?>