<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\PED\Modules\Pedidos\Factories\Ped05300RecalculoPrecoPedidoFactory;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\Libs\Util\Environment;



class Ped05300RecalculoPrecoPedidoService {
    
    protected $entityManager;
	protected $environment;
	protected $ParametrosWebServiceFactory;

	public function __construct(EntityManager $entityManager, Environment $environment, Ped05300RecalculoPrecoPedidoFactory $RecalculoPrecoPedidoFactory){
		$this->entityManager  = $entityManager;
		$this->environment	= $environment;
		$this->Ped05300RecalculoPrecoPedidoFactory = $RecalculoPrecoPedidoFactory;
	}
	public function RecalPrecoPed($row){
		$dataSetRecalc = array();
		if($row['IDOPCAO'] == 0){
			
			$adqItemPed = $this->Ped05300RecalculoPrecoPedidoFactory->getItemPed($row);
			
									
			if(!empty($adqItemPed)){
				$cdsPedido = array();
				$cdsItemPedAtual = array();
				$cdsItemPedNovo = array();
				
				foreach($adqItemPed as $pedido){
					$dtPedido = $pedido['DTPEDIDO'];
					$sitPedido = [1, 2, 6];
					$sitItem = [1, 2, 3, 7];
					$buscaPedido =[];

					if(in_array($pedido['IDSITPEDIDO'], $sitPedido)){
						$preco = 0;
						
						$adqPrecoPromo = $this->Ped05300RecalculoPrecoPedidoFactory->getPrecoPromo($pedido);

						if(is_null($adqPrecoPromo[0]['VRITEPREBASE']) || $adqPrecoPromo[0]['VRITEPREBASE'] <= 0){
							
							$adqPrecoBase = $this->Ped05300RecalculoPrecoPedidoFactory->getPrecoBase($pedido, $dtPedido);
							
							$preco = $adqPrecoBase[0]['VRITEPREBASE'];

						}else{
							$preco = $adqPrecoPromo[0]['VRITEPREBASE'];	
						}

						if($preco > 0){
							if($pedido['VRPREUNITPED'] != $preco && in_array($pedido['IDSITITEMPED'], $sitItem)){
								if(!array_key_exists($pedido['NRPEDIDO'], $cdsPedido)){
									$rows = array();
									
									$rows['CDFILIAL']	 = $pedido['CDFILIAL'];
									$rows['NRPEDIDO']	 = $pedido['NRPEDIDO'];
									$rows['IDMARCADO'] 	 = 'N';
									$rows['IDSITPEDIDO'] = $pedido['IDSITPEDIDO'];
									$rows['NMFANTCLIE']	 = $pedido['NMFANTCLIE'];
									$rows['DTPEDIDO']	 = $pedido['DTPEDIDO'];
									$rows['DTENTPED']	 = $pedido['DTENTPED'];
									$rows['CDVENDEDOR']	 = $pedido['CDVENDEDOR'];
									$rows['VRTOTAPED']	 = $pedido['VRTOTAPED'];
									$rows['NMFANVEN']	 = $pedido['NMFANVEN'];
									
									array_push($cdsPedido, $rows);
									
								}
								$itens = array();
								$itensNovos = array();
								
								$itens['CDFILIAL']		= $pedido['CDFILIAL'];			
		                        $itens['NRPEDIDO']		= $pedido['NRPEDIDO'];			
		                        $itens['NRITEMPED'] 	= $pedido['NRITEMPED']; 		
		                        $itens['IDSITITEMPED']	= $pedido['IDSITITEMPED'];	
		                        $itens['CDPRODUTO'] 	= $pedido['CDPRODUTO']; 		
		                        $itens['CDARVPROD'] 	= $pedido['CDARVPROD']; 		
		                        $itens['NMPRODUTO'] 	= $pedido['NMPRODUTO']; 		
		                        $itens['QTITEMPED'] 	= $pedido['QTITEMPED']; 		
		                        $itens['SGUNIDADE'] 	= $pedido['SGUNIDADE']; 		
		                        $itens['VRPREUNITPED']  = $pedido['VRPREUNITPED'];	
		                        $itens['VRDESITPED']	= $pedido['VRDESITPED'];		
		                        $itens['VRTOTAITEM']	= $pedido['VRTOTAITEM'];	
		                        $itens['DTENTITPED']	= $pedido['DTENTITPED'];		
		                        $itens['QTEXPITEMPED']  = $pedido['QTEXPITEMPED'];	
		                        $itens['IDITPEDDIFER']  = $pedido['IDITPEDDIFER'];	
		                        
		                        array_push($cdsItemPedAtual, $itens);
		                        
		                        $itensNovos['CDFILIAL'] 	=	$pedido['CDFILIAL'];
                    			$itensNovos['NRPEDIDO'] 	=	$pedido['NRPEDIDO'];
                    			$itensNovos['NRITEMPED']	=	$pedido['NRITEMPED'];
                    			$itensNovos['IDSITITEMPED']	=	$pedido['IDSITITEMPED'];
                    			$itensNovos['CDPRODUTO']	=	$pedido['CDPRODUTO'];
                    			$itensNovos['CDARVPROD']	=	$pedido['CDARVPROD'];
                    			$itensNovos['NMPRODUTO']	=	$pedido['NMPRODUTO'];
                    			$itensNovos['QTITEMPED']	=	$pedido['QTDEAEXP'];
                    			$itensNovos['SGUNIDADE']	=	$pedido['SGUNIDADE'];
                    			$itensNovos['VRPREUNITANT']	=	$preco;
                    			$itensNovos['VRPREUNITPED']	=	$preco;
                    			
		                        if($pedido['IDSITITEMPED']== '7'){
		                        	$vrDescIt = $pedido['VRDESITPED']/$pedido['QTDEAEXP']*$pedido['QTITEMPED'];	
		                        }else{
		                        	$vrDescIt = $pedido['VRDESITPED'];
		                        }
		                        $itensNovos['VRDESITPED']		= $vrDescIt;
		                        $itensNovos['VRTOTAITEM']		= (($pedido['QTDEAEXP'] * $preco) - -$vrDescIt);
		                        $itensNovos['QTEXPITEMPED'] 	= $pedido['QTEXPITEMPED'];
		                        $itensNovos['DTENTITPED']		= $pedido['DTENTITPED'];
		                        $itensNovos['IDITPEDDIFER'] 	= $pedido['IDITPEDDIFER'];
		                        $itensNovos['VRTOTAITEMANT']	= (($pedido['QTITEMPED'] * $preco) - $pedido['VRDESITPED']);
		                        $itensNovos['QTITEMPEDANT'] 	= $pedido['QTITEMPED'];
		                        
                    			
                    			array_push($cdsItemPedNovo, $itensNovos);
                    			
                    			$dataSetRecalc = array('cdsPedido'=>$cdsPedido,'cdsItemPedAtual'=> $cdsItemPedAtual, 'cdsItemPedNovo'=>$cdsItemPedNovo );
                    			
									
							}

						}
						
					}
				}
			}

		}
		return $dataSetRecalc;
	}
}

